// SQLSrvEnumeratorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SQLSrvEnumerator.h"
#include "SQLSrvEnumeratorDlg.h"

#include "SQLInfoEnumerator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSQLSrvEnumeratorDlg dialog

CSQLSrvEnumeratorDlg::CSQLSrvEnumeratorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSQLSrvEnumeratorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSQLSrvEnumeratorDlg)
	m_szSQLServer = _T("");
	m_szPassword = _T("");
	m_szUserId = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSQLSrvEnumeratorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSQLSrvEnumeratorDlg)
	DDX_Control(pDX, IDC_COMBOLANGUAGE, m_ctlLanguage);
	DDX_Control(pDX, IDC_COMBOSQLSERVERS, m_ctlServer);
	DDX_Control(pDX, IDC_COMBODATABASE, m_ctlDatabase);
	DDX_CBString(pDX, IDC_COMBOSQLSERVERS, m_szSQLServer);
	DDX_Text(pDX, IDC_EDITPASSWORD, m_szPassword);
	DDX_Text(pDX, IDC_EDITUSERID, m_szUserId);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSQLSrvEnumeratorDlg, CDialog)
	//{{AFX_MSG_MAP(CSQLSrvEnumeratorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_DROPDOWN(IDC_COMBODATABASE, OnDropdownCombodatabase)
	ON_CBN_DROPDOWN(IDC_COMBOSQLSERVERS, OnDropdownCombosqlservers)
	ON_CBN_DROPDOWN(IDC_COMBOLANGUAGE, OnDropdownCombolanguage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSQLSrvEnumeratorDlg message handlers

BOOL CSQLSrvEnumeratorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSQLSrvEnumeratorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSQLSrvEnumeratorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSQLSrvEnumeratorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSQLSrvEnumeratorDlg::OnDropdownCombosqlservers() 
{
	//Fill List of SQL Servers
	CWaitCursor wait;
	m_ctlServer.ResetContent();
	CSQLInfoEnumerator obSQLEnumerate;
	if(obSQLEnumerate.EnumerateSQLServers())
	{
		int iCount = obSQLEnumerate.m_szSQLServersArray.GetSize();
		for(int i = 0; i < iCount; i++)
		{
			m_ctlServer.AddString(obSQLEnumerate.m_szSQLServersArray[i]);
		}
	}
}

void CSQLSrvEnumeratorDlg::OnDropdownCombolanguage() 
{
	//Fill List of languages
	CWaitCursor wait;
	m_ctlLanguage.ResetContent();
	UpdateData();
	CSQLInfoEnumerator obSQLEnumerate;

	if(obSQLEnumerate.EnumerateDatabaseLanguage(m_szSQLServer,m_szUserId,m_szPassword))
	{
		int iCount = obSQLEnumerate.m_szSQLServerLanguageArray.GetSize();
		for(int i = 0; i < iCount; i++)
		{
			m_ctlLanguage.AddString(obSQLEnumerate.m_szSQLServerLanguageArray[i]);
		}
	}
}

void CSQLSrvEnumeratorDlg::OnDropdownCombodatabase() 
{
	//Fill List of Databases
	CWaitCursor wait;
	m_ctlDatabase.ResetContent();
	UpdateData();
	CSQLInfoEnumerator obSQLEnumerate;

	if(obSQLEnumerate.EnumerateDatabase(m_szSQLServer,m_szUserId,m_szPassword))
	{
		int iCount = obSQLEnumerate.m_szSQLServerDatabaseArray.GetSize();
		for(int i = 0; i < iCount; i++)
		{
			m_ctlDatabase.AddString(obSQLEnumerate.m_szSQLServerDatabaseArray[i]);
		}
	}
}
